Subject: bug#34651: guix commands should print a message, if they produce only trivial output by default

From: Björn Höfling <[email-masked]>
Date: Mon, 25 Feb 2019 17:24:56 +0100

I noticed that if you call "guix COMMAND" for some COMMANDs without any
options given, they produce something which is not very useful to the
user. I first noticed it with guix pack:

When "guix pack" is run without any options, it builds an empty pack:

$ guix pack
/gnu/store/2ys9fn6h95209piqhyxli5pf2c4mp7zp-tarball-pack.tar.gz
$ tar tzvf /gnu/store/2ys9fn6h95209piqhyxli5pf2c4mp7zp-tarball-pack.tar.gz
drwxrwxr-t root/root         0 1970-01-01 01:00 ./gnu/store/
dr-xr-xr-x root/root         0 1970-01-01 01:00 ./gnu/store/w659mjmzwyhv62sd35y2pv5nrg5xkl7j-profile/
dr-xr-xr-x root/root         0 1970-01-01 01:00 ./gnu/store/w659mjmzwyhv62sd35y2pv5nrg5xkl7j-profile/etc/
-r--r--r-- root/root       414 1970-01-01 01:00 ./gnu/store/w659mjmzwyhv62sd35y2pv5nrg5xkl7j-profile/etc/profile
-r--r--r-- root/root        37 1970-01-01 01:00 ./gnu/store/w659mjmzwyhv62sd35y2pv5nrg5xkl7j-profile/manifest

I think from a user perspective it would be better to print a help
message and not build an empty pack.

On the other hand, I tried out other guix commands and at least it is a
consistent behaviour, they start with the default values, like "guix
graph" outputs just an empty graph.

"guix system" complains it needs a subcommand, which is a different
case.

But then again we have this complaint:

guix system container
guix system: error: wrong number of arguments for action 'container'

WDYT?

Björn